unit oTermMappingTableEnumerator;

interface

uses
  Classes,
  SysUtils,
  iCPTerminology;

type
  TTermMappingTableEnumerator = class(TInterfacedObject, ITermMappingTableEnumerator)
  private
    fList: IInterfaceList;
    fIndex: integer;
  public
    constructor Create(aList: IInterfaceList);
    destructor Destroy; override;

    function GetCurrentIndex: integer; stdcall;
    function GetPercentageDone: integer; stdcall;
    function GetCurrentEntry: ITermMappingTableEntry; stdcall;
    function MoveNext: boolean; stdcall;
  end;

implementation

{ TTermMappingTableEnumerator }

constructor TTermMappingTableEnumerator.Create(aList: IInterfaceList);
begin
  inherited Create;
  fList := aList;
  fIndex := -1;
end;

destructor TTermMappingTableEnumerator.Destroy;
begin
  inherited;
end;

function TTermMappingTableEnumerator.GetCurrentEntry: ITermMappingTableEntry;
begin
  fList[fIndex].QueryInterface(ITermMappingTableEntry, Result);
end;

function TTermMappingTableEnumerator.GetCurrentIndex: integer;
begin
  Result := fIndex;
end;

function TTermMappingTableEnumerator.GetPercentageDone: integer;
begin
  Result := trunc((fIndex / fList.Count) * 100);
end;

function TTermMappingTableEnumerator.MoveNext: boolean;
begin
  Result := fIndex < fList.Count - 1;
  if Result then
    Inc(fIndex);
end;

end.

